/*
 * Copyright (c) Michael Thomas, All Rights Reserved. (michael@michael-thomas.com) 
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Exceptions must be in writing between the 
 * copyright holder and entity using the content.
 *
 * THE COPYRIGHT HOLDER MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. THE COPYRIGHT HOLDER SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/**
 * @author  Michael Thomas - michael@michael-thomas.com
 * @version 1.0 07/04/08
 */

package firststeps;

import java.util.Date;

public class ThreadsHelloWorldWaitNotify implements Runnable {
	
	private String strMsg = "";
	
    public String getStrMsg() {
		return strMsg;
	}

	public void setStrMsg(String strMsg) {
		this.strMsg = strMsg;
	}
	
	public void run() {
    	//The Thread's run() method.
        int intLoopCount = 5;
        String strThreadName = Thread.currentThread().getName();
        System.out.println(strThreadName + " - Start Time - " + (new Date()).toString());

    	for (int i = 1; i <= intLoopCount; i++) {
            
    		if ( i == 3 ) {
        		try {
        	        System.out.println(strThreadName + " - Let's wait() - " + (new Date()).toString());
        	        synchronized ( this ) {
        	          this.wait();
        	        }
                } catch (IllegalMonitorStateException e) {
        	        System.out.println(strThreadName + " - Illegal Monitor State Exception (IllegalMonitorStateException) - you can't do that! Try synchronized - " + (new Date()).toString());
        		} catch (InterruptedException e) {
        	        System.out.println(strThreadName + " - Interrupted Time - " + (new Date()).toString());
                }
    		}
            System.out.println( strThreadName + " - Hello World #" + i + " - " + getStrMsg() + (new Date()).toString());
        }
        System.out.println(strThreadName + " - Stop Time - " + (new Date()).toString());
    }

    public static void main(String args[]) throws InterruptedException {
    	
    	String strThreadName = Thread.currentThread().getName();
    	
    	System.out.println(strThreadName + " - Begin - " + (new Date()).toString());

    	//First Thread
    	ThreadsHelloWorldWaitNotify objRunnable1 = new ThreadsHelloWorldWaitNotify();
    	Thread objThreadHW1 = new Thread(objRunnable1, "ThreadHW1");
    	objThreadHW1.start();
    	
        System.out.println(strThreadName + " - before 2 second sleep - " + (new Date()).toString());
    	Thread.sleep(2 * 1000);
        System.out.println(strThreadName + " - after 2 second sleep - " + (new Date()).toString());

        objRunnable1.setStrMsg("Got it now! - ");
        
		try {
	        System.out.println(strThreadName + " - Let's objRunnable1.notify(); - " + (new Date()).toString());
	        synchronized ( objRunnable1 ) {
	        	objRunnable1.notify();
	          //objThreadHW1.notify(); //The tread does not have the monitor.  Runnable does.
	        }
        } catch (IllegalMonitorStateException e) {
	        System.out.println(strThreadName + " - Illegal Monitor State Exception (IllegalMonitorStateException) - you can't do that! - " + (new Date()).toString());
        }

        System.out.println(strThreadName + " - Finished - " + (new Date()).toString());
    
    }

}
